//************************************************************************
// Bitmap.C
//
// Bitmaps an beliebige Position zeichnen
//
// Der Nullpunkt der Anzeige ist links oben
//
// hk@holger-klabunde.de
// http://www.holger-klabunde.de
//************************************************************************
// 17.11.2006
//************************************************************************
// Compiler WinAVR 3.4.5
//************************************************************************
#include <avr/pgmspace.h>

#include "bitmap.h"
#include "lcd.h"
#include "param.h"


//##########################################################
void LoadBitmap_P(unsigned const char *bitmap,unsigned short xpos , unsigned short ypos, unsigned short width, unsigned short height)
//##########################################################
{
 unsigned char i,j,k;
 unsigned short by,mask,bwidth,yp,xp;
// unsigned char by,mask;
// unsigned int xend;     //xpos + width kann grer als 255 werden
 unsigned short xend;
 xend=(unsigned short)xpos + (unsigned short)width;
 if(xend>XSIZE) xend=XSIZE; //Bitmap abschneiden wenn auerhalb des Displays
 
 bwidth=width/8; //Anzahl Bytes horizontal /8
 if((width%8)!=0) bwidth++; //Bei Rest noch ein Byte mehr

 yp=ypos;
 for(i=0; i<height; i++) //ber die gesamte Hhe
  {
   xp=xpos; //Zum Beginn der Zeile
   
   for(j=0; j<bwidth; j++) //ber die gesamte Breite in Bytes
    {
	//lsst sich nur der Flash-Speicher zwischen 0k.. 64k adressieren.
     by=pgm_read_byte(bitmap);


     // by=pgm_read_byte_far(   0x10000UL +  (uint32_t) (uint16_t) bitmap);

	//lsst sich nur der Flash-Speicher zwischen 64k..128k adressieren.
	// by=pgm_read_byte_far(0x10000UL + (uint32_t) (uint16_t) bitmap);
	 mask=0x80;         //Fngt bei MSB an
    
     for(k=0; k<8; k++) //ber ein Byte
      {
        //Nur vorhandene und keine Fllpixel,-bytes zeichnen
       if(xp < (unsigned short)xend)
        {
        lcd_setpixel(xp,yp,(by & mask) );
         
		 xp++; 
        }                               

       mask>>=1; //Nchstes Bit
      }//for k

     bitmap++;
    } //for j

   yp++; //Nchste Zeile
  } //for i
}

