
#include <string.h>	

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <stdlib.h>
#include <portbits.h>
#include "param.h"
#include "global.h"
#include "lcd.h"
#include "uart.h"


//*****INCLUD-FILES FOR SD-CARD*********
#include "dos.h"			
#include "fat.h"			
#include "dosdefs.h"						
#include "mmc_spi.h"
#include "find_x.h"		


//*****INCLUD-FILES FOR SD-CARD*********



#include "bitmap.h"
#include "Rgb.h"  //Bitmap 640x177 Pixel


//***************************************************************************
//*																			*
//*					LCD Controller fr Dualscan 640x480 LCD					*
//*																			*
//*								mit UART									*
//*																			*
//*								Version 1.00								*
//*																			*
//*								 by Benedikt								*
//*																			*
//*						Email:	benedikt83 t gmx.net						*
//*																			*
//***************************************************************************
//*																			*
//*	Die Software darf frei kopiert und verndert werden, solange sie nicht	*
//*	ohne meine Erlaubnis fr kommerzielle Zwecke eingesetzt wird.			*
//*																			*
//***************************************************************************

#define UART_BAUD_RATE		   57600 






int main(void)
{	PORTD=1;
	//DDRB=255;
	DDRB = 0xFF;// Ausgang
	DDRD=254;
	DDRE=255;
	PORTA=255;
	PORTC=255;

	uart_init(UART_BAUD(UART_BAUD_RATE, F_CPU),UART_BAUD_U2X(UART_BAUD_RATE, F_CPU));
	lcd_init();									// LCD Controller initialisieren
	
	
	//lcd_clear();
	
	
	
	unsigned char c;
	unsigned char FontX=0, FontY=0 ;
	unsigned short xpos=0, ypos=0,sinx=250;





//BITMAP VOM FLASCH LADEN DAS GEHT
LoadBitmap_P(RGBbmp, 0 ,239, 640,177 );   //Bitmap laden



//*******************************************************
//*******************************************************


 MMC_IO_Init();

   









//********************************************************** 






//#########################################################################
//#########################################################################
//#########################################################################
//#########################################################################
//#########################################################################


/*

	for (;;)
	{	c = uart_getchar();
		if (c>31)				//Display Text
		{	lcd_writechar(xpos/4,ypos,c);
			xpos+=TEXT_X;
			if (xpos>=XSIZE)
			{	xpos=0;
				ypos+=TEXT_Y;
				if (ypos>=YSIZE)
					ypos=0;
			}
		}
*/


	for (;;)
	{	c = uart_getchar();
		if (c>31)				//Display Text
		{
		LCDSoftCharProp(c,xpos,ypos);//xpos,ypos);
			xpos+=FontX;
			if (xpos>=XSIZE)
			{	xpos=0;
				ypos+=FontY;
				if (ypos>=YSIZE)
					ypos=0;
			}
		}








		else if (c==1)			// Cursor Home
		{	xpos=0;
			ypos=0;
		}
		
		else if (c==2)			// GLCD FUNKTIONEN
		{   c=uart_getchar();
            if (c==1)			// GLCD ON
            ENABLE_VLCD=1;
		}
		    if (c==2)			// GLCD OFF
		{   ENABLE_VLCD=0;
		
		}		 
		    
            if (c==3)			// GLCD BACKLIGHT ON
		{   ENABLE_Backlight=1;
		
		}
		
            if (c==4)			// GLCD BACKLIGHT OFF
		{   ENABLE_Backlight=0;
		
		}

		/*else if (c==3)			// GLCD WINDOW FUNKTIONEN
		{   c=uart_getchar();
            if (c==180)			// GLCD WINDOW 1
            //lcd_setsite1(0, 0,0 );
		}
		    if (c==181)			// GLCD WINDOW 2
		{   //lcd_setsite2(0, 0,0 );
		
		}		 
		    
            if (c==182)			// GLCD WINDOW 3
		{   //lcd_setsite1(0, 0,0 );
		
		}
		
            if (c==183)			// GLCD WINDOW 4
		{   //lcd_setsite1(0, 0,0 );
		
		}
		*/
		else if (c==4)			// 
		{	
		   
		}
		else if (c==5)			// 
		{			
		
		    
		}
		else if (c==8)			// Backspace
		{	xpos-=TEXT_X;
			if (xpos>=32768)
			{	xpos=XSIZE-TEXT_X;
				ypos-=TEXT_Y;
				if (ypos>=32768)
					ypos=YSIZE-TEXT_Y;
			}
			lcd_writechar(xpos/4,ypos,32);
		}
		else if (c==9)			// Set Pixel
		{	CONVERTW x,y;
			x.b[0]=uart_getchar();
			x.b[1]=uart_getchar();
			y.b[0]=uart_getchar();
			y.b[1]=uart_getchar();
			c=uart_getchar();
			lcd_setpixel(x.w,y.w,c);
		}
		else if (c==10)        // Line Feed
		{	ypos+=TEXT_Y;
			if (ypos>=YSIZE) 
				ypos=0;
		}
		else if (c==11)        // Delete in place
		{	lcd_writechar(xpos/4,ypos,32);
		}
		else if (c==12)        // Form Feed
		{	xpos=0;
			ypos=0;
			lcd_clear();
		}
		else if (c==13)			// Carriage Return
		{	xpos=0;
		}
		else if (c==14)			// Set Brightness
		{	c=uart_getchar();
		}
		else if (c==15)			// Set Contrast
		{	c=uart_getchar();
			if (c>100)
				c=100;
			OCR1B=c*2+c/2;
		}	
		else if (c==16)			//Load BMP
		{	CONVERTW y1,ys;
			unsigned short y;
			unsigned char x1,xs,x,c;
			if (uart_getchar()==0xAA)
			{	x1=uart_getchar();
    			y1.b[0]=uart_getchar();
    			y1.b[1]=uart_getchar();
    			xs=uart_getchar();
    			ys.b[0]=uart_getchar();
    			ys.b[1]=uart_getchar();
    			for (y=0; y<ys.w; y++)
    			{	for (x=0; x<xs; x++)
    				{	c=uart_getchar();
    					lcd_writebyte(x*2+x1,y+y1.w,c,0);
    				}
				}
			}
		}
		else if (c==17)        // Set Cursor Position (Column and Row)
		{	CONVERTW y;
			xpos=uart_getchar();
			y.b[0]=uart_getchar();
			y.b[1]=uart_getchar();
			ypos=y.w;
        }

		else if (c==18)			// SET FONT
		{ c=uart_getchar();

		 if (c==1)			// Cursor Home
		{SetFont(6);
		 FontX = TEXT_X2;
         FontY = TEXT_Y2;
		}		 
		 if (c==2)			// Cursor Home
		    { SetFont(7);
		      FontX = TEXT_X2;
              FontY = TEXT_Y2;
		}
		 if (c==3)			// Cursor Home
		    { SetFont(8);
		      FontX = TEXT_X3;
              FontY = TEXT_Y3;
        xpos=xpos*5;//TEXT_X3;
		
		if (c==4)			// Cursor Home
		    {
		}


		    }		 		 
	    }		 
		else if (c==19)			// Draw Line
		{	CONVERTW x1,y1,x2,y2;
			x1.b[0]=uart_getchar();
			x1.b[1]=uart_getchar();
			y1.b[0]=uart_getchar();
			y1.b[1]=uart_getchar();
			x2.b[0]=uart_getchar();
			x2.b[1]=uart_getchar();
			y2.b[0]=uart_getchar();
			y2.b[1]=uart_getchar();
			lcd_line (x1.w,y1.w,x2.w,y2.w,c);
		
		
		
		}
		else if (c==20)				// Draw Circle
		{	CONVERTW x,y;
			unsigned char c2,r;
			x.b[0]=uart_getchar();
			x.b[1]=uart_getchar();
			y.b[0]=uart_getchar();
			y.b[1]=uart_getchar();
			r=uart_getchar();
			c=uart_getchar();
			c2=uart_getchar();
			lcd_circle (x.w,y.w,r,c,c2);
		

		}
		else if (c==21)			// Scroll
		{	uart_getchar();
			uart_getchar();
		}
		else if (c==22)			// Enable Scroll
		{	uart_getchar();
			uart_getchar();
			uart_getchar();
		
		}
		else if (c==25)				// Get CGRAM
		{	c=uart_getchar();
			c&=7;
			for (unsigned char i=0; i<8; i++)
				cgram[c][i]=uart_getchar();
		}
		

		
		else if (c==28)			// Large Number
		{	uart_getchar();
			uart_getchar();
			uart_getchar();
		}
		else if (c==29)				// Draw Block
		{	CONVERTW x1,x2,y1,y2;
			unsigned char c2;
			x1.b[0]=uart_getchar();
			x1.b[1]=uart_getchar();
			y1.b[0]=uart_getchar();
			y1.b[1]=uart_getchar();
			x2.b[0]=uart_getchar();
			x2.b[1]=uart_getchar();
			y2.b[0]=uart_getchar();
			y2.b[1]=uart_getchar();
			c=uart_getchar();
			c2=uart_getchar();
			lcd_block (x1.w,y1.w,x2.w,y2.w,c,c2);
		}
		else if (c==30)			// Send directly
		{	c=uart_getchar();
			if (c==0)
				lcd_writecgram(xpos/4,ypos,uart_getchar());
			else
				lcd_writechar(xpos/4,ypos,uart_getchar());
   			xpos+=TEXT_X;
   			if (xpos>=XSIZE)
   			{	xpos=0;
   				ypos+=TEXT_Y;
   				if (ypos>=YSIZE)
   					ypos=0;
			}
		}
	}
}

